diff --git a/rathaxes/samples/e1000/e1000.blt b/rathaxes/samples/e1000/e1000.blt
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/e1000.blt
+++ b/rathaxes/samples/e1000/e1000.blt
@@ -727,300 +572,178 @@
             }
         }
 
-        chunk   ::CALL()
+        chunk Ethernet::HardwareContext()
         {
-            rtx_e1000_print_status(&${rtx_ether_ctx}->hw_ctx);
-        }
-    }
-
-    /*
-     * We should have been able to do something along those lines, but
-     * it didn't work so we made the call manually.
-     *
-     * Ideally:
-     * ${e1000::register_read32(rtx_ether_ctx->hw_ctx, E1000_STATUS)};
-     *
-     * Ideally2, not sure about the syntax on the register parameter:
-     * ${e1000::register_read32(rtx_ether_ctx->hw_ctx, ${e1000::Register.E1000_STATUS})};
-     *
-     * "Acceptable":
-     * ${e1000::Register} reg_status;
-     * ${e1000.init(E1000_STATUS); // didn't work, so we used the next line
-     * reg_status = E1000_STATUS;
-     * ${e1000::register_read32(rtx_ether_ctx->hw_ctx, reg_status)};
-     *
-     * TODO: make them methods of e1000::Context
-     */
-    template sequence   e1000::register_read32(e1000::Context ctx, e1000::Register reg_offset)
-    {
-        chunk   LKM::prototypes()
-        {
-            /* FIXME: See issue #54 */
-            static unsigned int    rtx_e1000_register_read32(/*const*/ ${e1000::Context.ref}, unsigned int);
+            ${e1000::Context}   hw_ctx;
         }
 
-        chunk   LKM::code()
+        chunk Ethernet::adapter_init_context(Ethernet::Device rtx_ether_ctx, Builtin::symbol ioaddr)
         {
-            /* FIXME: See issue #54 */
-            static unsigned int    rtx_e1000_register_read32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset)
             {
-                return ioread32(ctx->ioaddr + reg_offset);
+                ${e1000::Context.ref} hw_ctx = &${local.rtx_ether_ctx}->hw_ctx;
+                ${local.hw_ctx.io.init(local.ioaddr)};
+                ${local.hw_ctx.rx_ring.init(local.hw_ctx.io, config.rx_ring_size)};
+                ${local.hw_ctx.tx_ring.init(local.hw_ctx.io, config.tx_ring_size)};
             }
         }
 
-        chunk   ::CALL()
+        chunk Ethernet::adapter_reset(Ethernet::Device rtx_ether_ctx)
         {
-            rtx_e1000_register_read32(${ctx}, ${reg_offset});
-        }
-    }
-
-    template sequence   e1000::register_write32(e1000::Context ctx, e1000::Register reg_offset, ::number value)
-    {
-        chunk   LKM::prototypes()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_write32(/*const*/ ${e1000::Context.ref}, unsigned int, unsigned int);
-        }
-
-        chunk   LKM::code()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_write32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset, unsigned int value)
             {
-                iowrite32(value, ctx->ioaddr + reg_offset);
+                ${e1000::Context.ref} hw_ctx = &${local.rtx_ether_ctx}->hw_ctx;
+                // XXX #46: ${local.hw_ctx.io.write32(E1000_CTRL, E1000_CMD_RST)};
+                rtx_e1000_reg_write32(hw_ctx, E1000_CTRL, E1000_CMD_RST);
+                udelay(10); // TODO: abstract this too...
+                ${Log::info("adapter has been reset")};
             }
         }
 
-        chunk   ::CALL()
+        chunk Ethernet::adapter_load_mac_address(Ethernet::Device rtx_ether_ctx)
         {
-            rtx_e1000_register_write32(${ctx}, ${reg_offset}, ${value});
-        }
-    }
+            {
+                ${e1000::Context.ref} hw_ctx = &${local.rtx_ether_ctx}->hw_ctx;
+                // Shamelessly borrowed from Minix
+                for (int i = 0; i < 3; ++i) {
+                    rtx_e1000_reg_write32(hw_ctx, E1000_EEPROM_READ, (i << 8) | 1);
+                    int value;
+                    do {
+                        value = rtx_e1000_reg_read32(hw_ctx, E1000_EEPROM_READ);
+                    } while ((value & (1 << 4)) == 0);
+                    value >>= 16;
+                    // NOTE: I'm not sure if Ethernet::Device should be
+                    // accessed directly here. But since we need to take it in
+                    // parameter (so we can get back our e1000::Context) it
+                    // seems inadequate to set this in another way:
+                    ${local.rtx_ether_ctx.dev_addr}[i * 2] = value & 0xff;
+                    ${local.rtx_ether_ctx.dev_addr}[i * 2 + 1] = (value >> 8) & 0xff;
+                }
 
-    template sequence   e1000::register_set32(e1000::Context ctx, e1000::Register reg_offset, ::number value)
-    {
-        chunk   LKM::prototypes()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_set32(/*const*/ ${e1000::Context.ref}, unsigned int, unsigned int);
-        }
-
-        chunk   LKM::code()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_set32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset, unsigned int value)
-            {
-                iowrite32(rtx_e1000_register_read32(ctx, reg_offset) | value, ctx->ioaddr + reg_offset);
+                ${Log::info("mac address loaded from the EEPROM")};
             }
         }
 
-        chunk   ::CALL()
+        // For e1000, this part is documented in the Intel Gigabit Ethernet
+        // Controller Software Developper manual. (You can find it in the
+        // doc/hardware directory).
+        chunk Ethernet::adapter_setup_rx_tx(Ethernet::Device rtx_ether_ctx)
         {
-            rtx_e1000_register_set32(${ctx}, ${reg_offset}, ${value});
-        }
-    }
+            {
+                ${e1000::Context.ref} hw_ctx = &${local.rtx_ether_ctx}->hw_ctx;
 
-    template sequence   e1000::register_unset32(e1000::Context ctx, e1000::Register reg_offset, ::number value)
-    {
-        chunk   LKM::prototypes()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_unset32(/*const*/ ${e1000::Context.ref}, unsigned int, unsigned int);
-        }
+                // "General Configuration" (section 14.3):
+                //
+                // - CTRL.ASDE/CTRL.SLU: Let the PHY handle the speed detection &
+                //   negociation;
+                // - CTRL.LRST/FRCSPD: Unset them to initiate the auto-negociation;
+                // - CTRL.PHY_RST: Unset it;
+                // - CTRL.ILOS: Unset it (ILOS is Invert Loss Of Signal);
+                // - CTRL.VME: Make sure it's not set to disable VLAN support;
+                // - Set the control flow registers to 0;
+                // - Finally, initialize all the statistic registers from
+                //   E1000_CRCERRS to E1000_TSCTFC.
+                //
+                // XXX #46: Use the read/write/set/unset methods on Context
+                rtx_e1000_reg_set32(hw_ctx, E1000_CTRL, E1000_CMD_ASDE|E1000_CMD_SLU);
+                rtx_e1000_reg_unset32(
+                    hw_ctx,
+                    E1000_CTRL,
+                    E1000_CMD_LRST|E1000_CMD_FRCSPD|E1000_CMD_PHY_RST|
+                    E1000_CMD_ILOS|E1000_CMD_VME
+                );
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCAH, 0);
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCAL, 0);
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCT, 0);
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCTTV, 0);
+                for (int i = 0; i != 64; ++i)
+                    rtx_e1000_reg_write32(hw_ctx, E1000_CRCERRS + i * 4, 0);
 
-        chunk   LKM::code()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_unset32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset, unsigned int value)
-            {
-                iowrite32(rtx_e1000_register_read32(ctx, reg_offset) & ~value, ctx->ioaddr + reg_offset);
+                ${Log::info("adapter_setup: general configuration done")};
             }
         }
 
-        chunk   ::CALL()
+        chunk Ethernet::adapter_enable_interrupts(Ethernet::Device)
         {
-            rtx_e1000_register_unset32(${ctx}, ${reg_offset}, ${value});
-        }
-    }
+            {
+                ${e1000::Context.ref} hw_ctx = &${local.rtx_ether_ctx}->hw_ctx;
+                rtx_e1000_reg_write32(
+                    hw_ctx,
+                    E1000_IMS,
+                    E1000_INTR_TXDW|E1000_INTR_TXQE|E1000_INTR_LSC|
+                    E1000_INTR_RXO|E1000_INTR_RXT0
+                );
 
-    template sequence   activate_device_interruption(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk  ::CALL()
-        {
-            rtx_e1000_register_write32(&${rtx_ether_ctx}->hw_ctx, E1000_IMS,
-                                       E1000_INTR_TXDW |
-                                       E1000_INTR_TXQE |
-                                       E1000_INTR_LSC  |
-                                       E1000_INTR_RXO  |
-                                       E1000_INTR_RXT0);
-        }
-    }
-
-    /* TODO:
-     *
-     * Refactor into two methods (one in RxRing and one in TxRing) and make use
-     * of the new methods in Socket::SKBuff.
-     */
-    template sequence   free_rx_tx(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk   ::CALL()
-        {
-            /*
-             * XXX: Not generated if named "hw_ctx" (which is funny because
-             * it's used and works in the template right above this one):
-             */
-            ${e1000::Context.ref} hw_ctx_;
-            hw_ctx_ = &${rtx_ether_ctx}->hw_ctx;
-
-            /*
-             * Free the rx ring:
-             * - Unmap and free the skbuffs;
-             * - Free the descriptors array.
-             */
-            for (int i = 0; i != ${config.rx_ring_size}; ++i)
-            {
-                /*
-                 * XXX Leaking casts:
-                 *
-                 * We should go through the rtx types (Socket::SKBuff,
-                 * AbstractSKBuff), but we can't because of the array here,
-                 * which is not supported by the compiler.
-                 */
-                dma_unmap_single(
-                        ${rtx_ether_ctx.device},
-                        *((dma_addr_t *)&(hw_ctx_->rx_ring.skbuffs[i].dma_handle)),
-                        ${config.rx_buffer_len},
-                        DMA_FROM_DEVICE);
-                dev_kfree_skb((struct sk_buff *)hw_ctx_->rx_ring.skbuffs[i].skbuff);
-            }
-            dma_free_coherent(${rtx_ether_ctx.device}, hw_ctx_->rx_ring.size,
-                    hw_ctx_->rx_ring.base, hw_ctx_->rx_ring.dma_base);
-            ${Log::info("free_rx_tx: rx ring free'ed")};
-
-            /*
-             * Free the tx ring:
-             * - Free the descriptors array.
-             */
-            dma_free_coherent(${rtx_ether_ctx.device}, hw_ctx_->tx_ring.size,
-                    hw_ctx_->tx_ring.base, hw_ctx_->tx_ring.dma_base);
-            ${Log::info("free_rx_tx: tx ring free'ed")};
-        }
-    }
-
-    template sequence   handle_interrupt(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk   ::CALL()
-        {
-            unsigned int icr = rtx_e1000_register_read32(&${rtx_ether_ctx}->hw_ctx, E1000_ICR);
-            pr_info("%s: interrupt received, ICR: 0x%x", ${config.name}, icr);
-            if (icr)
-            {
-                if (icr & E1000_INTR_LSC)
-                {
-                    ${Log::info("handle_interrupt: cable link status changed, dumping card status:")};
-                    ${e1000::print_status(rtx_ether_ctx)};
-                }
-                if (icr & (E1000_INTR_TXQE|E1000_INTR_TXDW))
-                {
-                    ${Log::info("handle_interrupt: TxRing: packet(s) sent")};
-                    /*
-                     * XXX Do a Rathaxes call (how can I bind
-                     * "&${rtx_ether_ctx}->hw_ctx.tx_ring" to e1000::TxRing easily?)
-                     */
-                    rtx_e1000_tx_ring_clean(&${rtx_ether_ctx}->hw_ctx.tx_ring);
-                }
-                if (icr & E1000_INTR_RXT0)
-                {
-                    ${Log::info("handle_interrupt: RxRing: packet(s) received")};
-                }
-                if (icr & E1000_INTR_RXO)
-                {
-                    ${Log::info("handle_interrupt: RxRing: overrun")};
-                }
-
-                return IRQ_HANDLED;
+                // XXX We should probably move that elsewhere (it just used to
+                // be done right after we enabled interrupts when this was
+                // still in lkm.rtx):
+                // XXX #46: ${local.hw_ctx.print_status()};
+                rtx_e1000_print_status(hw_ctx);
             }
         }
-    }
 
-    template sequence   e1000::xmit(Ethernet::Device rtx_ether_ctx, Socket::AbstractSKBuff kernel_skb)
-    {
-        chunk   ::CALL()
+        chunk Ethernet::disable_interrupts(Ethernet::Device rtx_ether_ctx)
         {
-            /*
-             * Put packets on the TX ring, must return NETDEV_TX_OK or
-             * NETDEV_TX_BUSY.
-             */
+            { ${Log::info("adapter_disable_interrupts: TBD...")}; }
+        }
 
-            ${Socket::SKBuff} skb;
-            ${e1000::Context.ref} hw_ctx;
-            ${e1000::TxRing.ref} tx_ring;
-            ${Device::AbstractDevice.ref} devp;
+        chunk Ethernet::adapter_handle_interrupt(Ethernet::Device rtx_ether_ctx)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${local.rtx_ether_ctx}->hw_ctx;
+                unsigned int icr = rtx_e1000_reg_read32(hw_ctx, E1000_ICR);
+                pr_info("%s: interrupt received, ICR: 0x%x", ${config.name}, icr);
+                if (icr) {
+                    if (icr & E1000_INTR_LSC) {
+                        ${Log::info("handle_interrupt: cable link status changed, dumping card status:")};
+                        // XXX #46: ${local.hw_ctx.print_status()};
+                        rtx_e1000_print_status(hw_ctx);
+                    }
+                    if (icr & (E1000_INTR_TXQE|E1000_INTR_TXDW)) {
+                        ${Log::info("handle_interrupt: TxRing: packet(s) sent")};
+                    }
+                    if (icr & E1000_INTR_RXT0) {
+                        ${Log::info("handle_interrupt: RxRing: packet(s) received")};
+                    }
+                    if (icr & E1000_INTR_RXO) {
+                        ${Log::info("handle_interrupt: RxRing: overrun")};
+                    }
 
-            ${local.skb.init(kernel_skb)};
-            hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-            tx_ring = &hw_ctx->tx_ring;
-            devp = (${Device::AbstractDevice.ref})${rtx_ether_ctx.device};
+                    // XXX: This sucks since we don't know the pointcut context:
+                    return IRQ_HANDLED;
+                }
+            }
+        }
 
-            ${Log::info("xmit: skbuff details:")};
-            /*
-             * skb does not expand on the bound C variable (should be
-             * rtx_skbuff), which is funny because it works for the
-             * sequence template call right after.
-             */
-            /*
-             * XXX: doesn't work (I tried to pass self explicitely too):
-             * ${local.skb.dump_infos()};
-             */
-            rtx_socket_skbuff_dump_infos(&skb);
+        chunk Ethernet::adapter_xmit(Ethernet::Device rtx_ether_ctx, Socket::SKBuff rtx_skb)
+        {
+            { ${Log::info("adapter_xmit: TBD...")}; }
+        }
 
-            /*
-             * The transmission is going to be several steps:
-             * 1. TCP Segmentation Offload & Checksum Offloading: pick a
-             *    descriptor from the tx ring and fill it as a context
-             *    descriptor to allow the card to slice into several packets
-             *    according to the MSS;
-             * 2. DMA Map the skbuff data as slices of 4096;
-             * 3. Signal the hardware that data is available via a tx desc.
-             */
+        chunk Ethernet::adapter_disable_rx(Ethernet::Device rtx_ether_ctx)
+        {
+            { ${Log::info("adapter_disable_rx: TBD..")}; }
+        }
 
-            /* XXX: same thing wanted to use: ${local.tx_ring.descriptors_remaining()} */
-            if (!rtx_e1000_tx_ring_descriptors_remaining(tx_ring))
-                return NETDEV_TX_BUSY;
+        chunk Ethernet::adpater_disable_tx(Ethernet::Device rtx_ether_ctx)
+        {
+            { ${Log::info("adapter_disable_tx: TBD..")}; }
+        }
 
-            /* 1. Offloading */
+        chunk Ethernet::adapter_free_rx_tx(Ethernet::Device rtx_ether_ctx)
+        {
+            { ${Log::info("adapter_free_rx_tx: TBD..")}; }
+        }
 
-            /* XXX: ${local.tx_ring.tso_cksum_offload(skb)}; */
-            if (rtx_e1000_tx_ring_tso_cksum_offload(tx_ring, &skb))
-            {
-                ${Log::info("xmit: the packet needs to be fragmented and/or checksummed but this not implemented yet!")};
-                goto err_offload;
-            }
 
-            /* 2. Map the data */
+        method print_status()
+        {
+            rtx_e1000_print_status(${self});
+        }
 
-            /* XXX: ${local.skb.map_to(devp.k_device)}; */
-            if (rtx_socket_skbuff_map(&skb, ${devp.k_device}, DMA_TO_DEVICE))
-            {
-                ${Log::info("xmit: can't DMA map a SKbuff")};
-                goto err_skb_map_to;
-            }
-
-            /* 3. Update the TX Ring and signal the hardware */
-
-            /* XXX: ${local.tx_ring.put(skb)}; */
-            rtx_e1000_tx_ring_put(tx_ring, &skb);
-
-            /* XXX: ${local.tx_ring.start_xmit(hw_ctx)}; */
-            rtx_e1000_tx_ring_start_xmit(tx_ring, hw_ctx);
-
-            return NETDEV_TX_OK;
-
-        err_offload:
-        err_skb_map_to:
-            /* XXX: ${local.skb.unmap_to_and_free(local.dev)}; */
-            rtx_socket_skbuff_unmap_and_free(&skb, ${devp.k_device}, DMA_TO_DEVICE);
-            return NETDEV_TX_OK;
+        map
+        {
+            io: ${self}->io;
+            rx_ring: ${self}->rx_ring;
+            tx_ring: ${self}->tx_ring;
         }
     }
 }
diff --git a/rathaxes/samples/e1000/e1000.rti b/rathaxes/samples/e1000/e1000.rti
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/e1000.rti
+++ b/rathaxes/samples/e1000/e1000.rti
@@ -1,157 +1,115 @@
 interface e1000 : Socket, Ethernet, DMA, PCI, LKM, Builtin
 {
-    required variable   Builtin::number rx_ring_size;
-    required variable   Builtin::number tx_ring_size;
-    required variable   Builtin::number rx_buffer_len;
-    required variable   Builtin::number tx_max_data_per_desc;
+    required variable Builtin::number rx_ring_size;
+    required variable Builtin::number tx_ring_size;
+    required variable Builtin::number rx_buffer_len;
+    required variable Builtin::number tx_max_data_per_desc;
 
-    provided type   RxDescriptor
+    // Hardware values/data structures, should probably be in the front-end:
+    provided type   Register            { decl data_types(); }
+    provided type   Command             { decl data_types(); }
+    provided type   TxDescriptorFlag    { decl data_types(); }
+    provided type   RxDescriptor        { decl data_types(); }
+    provided type   TxDescriptor        { decl data_types(); }
+
+    provided type   Buffer
     {
-        chunk       LKM::includes();
         decl        data_types();
-        method      init();
+
+        method      init(Socket::SKBuff, DMA::DMAHandle);
+
+        attribute   Socket::SKBuff.ref  sk_buff;
+        attribute   DMA::DMAHandle.ref  dma;
     }
 
-    provided type   TxDescriptor
+    // I wish we could just leave those methods in the Context type but we also
+    // need them from the rings and that would mean a circular dependency
+    // between the context and the rings and Rathaxes can't handle it.
+    provided type   MMIO
     {
         decl        data_types();
-        method      init();
+
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+
+        method      init(Builtin::symbol);
+        method      read32(Register);
+        method      write32(Register, Builtin::number);
+        method      set32(Register, Builtin::number);
+        method      unset32(Register, Builtin::number);
+
+        attribute   Builtin::symbol.scalar  io;
+    }
+
+    provided type   Ring
+    {
+        decl        data_types();
+
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+
+        method      init(MMIO, Builtin::number, Builtin::number);
+
+        attribute   MMIO.scalar             io;
+        attribute   DMA::DMAHandle.scalar    dma;
+        attribute   Builtin::number.scalar  size;   // Total size in bytes
+        attribute   Builtin::symbol.ref     descs;
+        attribute   Buffer.ref              buffs;
     }
 
     provided type   RxRing
     {
         decl        data_types();
-        method      init();
 
-        /* XXX: Callback that should be in the front-end: */
-        chunk       Ethernet::adapter_init_rx(Ethernet::Device);
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
 
-        attribute   DMA::DMAHandle.scalar   dma_base;
-        attribute   Builtin::number.scalar  size;
+        method      init(MMIO, Builtin::number);
+        method      alloc(); // Returns != 0 on failure
+
+        attribute   RxDescriptor.scalar descs;
+    }
+
+    provided type   TxRing
+    {
+        decl        data_types();
+
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+
+        method      init(MMIO, Builtin::number);
+        method      alloc(); // Returns != 0 on failure
+
+        attribute   TxDescriptor.scalar descs;
     }
 
     provided type   Context
     {
-        chunk       Ethernet::HardwareContext();
         decl        data_types();
 
-        /* XXX:
-         * These callbacks/Hooks which should probably be in the front-end.
-         * Also, I'm not too happy about the names, it's difficult to make
-         * the difference between the probe and open parts.
-         */
-        chunk       Ethernet::adapter_init_context(Ethernet::Device,
-                                                   Builtin::number,
-                                                   Builtin::symbol);
+        chunk       LKM::includes();
+        chunk       LKM::prototypes();
+        chunk       LKM::code();
+        chunk       Ethernet::HardwareContext();
+
+        // NOTE: Those callbacks/hooks should probably be in the front-end:
+
+        chunk       Ethernet::adapter_init_context(Ethernet::Device, Builtin::symbol);
         chunk       Ethernet::adapter_reset(Ethernet::Device);
         chunk       Ethernet::adapter_load_mac_address(Ethernet::Device);
-        chunk       Ethernet::adapter_setup(Ethernet::Device);
+        chunk       Ethernet::adapter_setup_rx_tx(Ethernet::Device);
+        chunk       Ethernet::adapter_enable_interrupts(Ethernet::Device);
+        chunk       Ethernet::adapter_disable_interrupts(Ethernet::Device);
+        chunk       Ethernet::adapter_handle_interrupt(Ethernet::Device);
+        chunk       Ethernet::adapter_xmit(Ethernet::Device, Socket::SKBuff);
+        chunk       Ethernet::adapter_disable_rx(Ethernet::Device);
+        chunk       Ethernet::adapter_disable_tx(Ethernet::Device);
+        chunk       Ethernet::adapter_free_rx_tx(Ethernet::Device);
 
+        method      print_status();
+
+        attribute   MMIO.scalar     io;
         attribute   RxRing.scalar   rx_ring;
-        /* XXX: circular dependency with Contex: */
-        //attribute   TxRing.scalar   tx_ring;
-    }
-
-    provided type   TxRing
-    {
-        chunk       LKM::prototypes();
-        chunk       LKM::code();
-        decl        data_types();
-        method      init();
-
-        /* XXX: Callback that should be in the front-end: */
-        chunk       Ethernet::adapter_init_tx(Ethernet::Device);
-
-        /* Clean the ring (i.e: move the head closer to the tail): */
-        method      clean();
-        /* Return the number of clean descriptors left in the ring: */
-        method      descriptors_remaining();
-        method      tso_cksum_offload(Socket::SKBuff);
-        method      put(Socket::SKBuff);
-        /* Signal the device that new dirty descriptors are on the ring: */
-        method      start_xmit(e1000::Context);
-    }
-
-    /*
-     * These two types should actually be registers definitions in the frontend:
-     */
-    provided type   Register
-    {
-        decl        data_types();
-        method      init(Builtin::number);
-    }
-
-    provided type   Commands
-    {
-        decl        data_types();
-    }
-
-    provided type   TxDescriptorFlags
-    {
-        decl        data_types();
-    }
-
-    /*
-     * This should take an e1000::Context as the first argument but this was
-     * not working as wished.
-     */
-    provided sequence   print_status(Ethernet::Device)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   activate_device_interruption(Ethernet::Device)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   set_up_device(Ethernet::Device)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   free_rx_tx(Ethernet::Device dev)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   handle_interrupt(Ethernet::Device)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   xmit(Ethernet::Device, Socket::AbstractSKBuff)
-    {
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_read32(e1000::Context, e1000::Register)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_write32(e1000::Context, e1000::Register, ::number)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_set32(e1000::Context, e1000::Register, ::number)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
-    }
-
-    provided sequence   register_unset32(e1000::Context, e1000::Register, ::number)
-    {
-        provided chunk  LKM::prototypes();
-        provided chunk  LKM::code();
-        provided chunk  ::CALL();
+        attribute   TxRing.scalar   tx_ring;
     }
 }
